<form nz-form [formGroup]="form">
  <div nz-row [nzGutter]="[30,60]">
    <div nz-col nzXs="24" nzLg="12">
      <mb-input-text formControlName="name" [mbMaxLength]="255"
        [mbType]="isSubmitted && form.controls['name'].errors ? 'error' : 'default'"
        [mbShowError]="isSubmitted && form.controls['name'].errors != null" [mbErrors]="form.controls['name'].errors"
        [mbErrorDefs]="[
          { errorName: 'required',errorDescription: 'staffAbs.approvalFlow.flowNameRequire' | translate },
          { errorName: 'maxlength', errorDescription: 'staffAbs.validate.maxLength' | translate: {'numberLength': 255} }
        ]"
        mbPlaceholderText="--{{'staffAbs.approvalFlow.flowName' | translate}}--"
        mbLabelText="{{'staffAbs.approvalFlow.flowName' | translate}} <span class='label__required'>*</span>">
      </mb-input-text>
    </div>
  </div>
  <!-- Danh sách loại nghỉ -->
  <ng-container formArrayName="listReasons">
    <ng-container *ngFor="let reason of reasons.controls; let idx = index; let first = first">
      <div nz-row [nzGutter]="[30, 60]" [formGroupName]="idx" nzJustify="start">
        <div nz-col nzXs="24" nzLg="6">
          <mb-select [mbDataSelects]="listResonCode"
            [mbType]="isSubmitted && reason.get('reasonCode').errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && reason.get('reasonCode').errors != null"
            [mbErrors]="reason.get('reasonCode').errors"
            [mbErrorDefs]="[
                        { errorName: 'required', errorDescription: 'staffAbs.approvalFlow.reasonCodeRequire' | translate},
                        { errorName: 'dublicate', errorDescription: 'staffAbs.validate.dublicate' | translate}
                        ]" mbPlaceholder="--{{'staffAbs.approvalFlow.reasonCode' | translate}}--"
            mbLabelText="{{'staffAbs.approvalFlow.reasonCode' | translate}} <span class='label__required'>*</span>"
            formControlName="reasonCode"></mb-select>
        </div>
        <div nz-col nzXs="24" nzLg="6">
          <mb-input-text appNumberic [num]='5' formControlName="maxDay"
            [mbType]="isSubmitted && reason.get('maxDay').errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && reason.get('maxDay').errors != null"
            [mbErrors]="reason.get('maxDay').errors" [mbErrorDefs]="[
                           { errorName: 'required',
                           errorDescription: 'staffAbs.approvalFlow.maxDayRequire' | translate
                           },
                           { errorName: 'max', errorDescription: 'staffAbs.validate.maxLength' | translate: {'maxValue': 100000} },
                           { errorName: 'min', errorDescription: 'staffAbs.validate.minValue' | translate: {'minValue': 1}},
                           { errorName: 'dublicate', errorDescription: 'staffAbs.validate.dublicate' | translate}
                       ]" mbPlaceholderText="--{{'staffAbs.approvalFlow.maxDay' | translate}}--"
            mbLabelText="{{'staffAbs.approvalFlow.maxDay' | translate}} <span class='label__required'>*</span>">
          </mb-input-text>
        </div>

        <div nz-col nzXs="24" nzLg="6" class="area-action">
          <mb-button mbButtonIconType="AWESOME" mbPrefixIcon="far fa-plus-circle" mbButtonSize="VERY_LARGE"
            mbButtonTextColor="#fff" mbButtonType="NO_BORDER" (click)="addReason()" mbButtonBgColor="#141ED2">
          </mb-button>

          <mb-button mbButtonIconType="AWESOME" mbPrefixIcon="far fa-trash-alt" mbButtonSize="VERY_LARGE"
            [mbIsDisable]="first" mbButtonTextColor="#fff" mbButtonType="NO_BORDER" (click)="removeReason(idx)"
            mbButtonBgColor="#FA0B0B">
          </mb-button>
        </div>
      </div>
    </ng-container>
  </ng-container>
  <!-- Danh sách cấp chức danh  -->
  <ng-container formArrayName="registerLevels">
    <div *ngFor="let registerLevel of registerLevels.controls; let idx = index; let first = first">
      <div nz-row [nzGutter]="[30, 60]" [formGroupName]="idx" nzJustify="start">
        <div nz-col nzXs="24" nzLg="6">
          <mb-select formControlName="registerLevelId" [mbDataSelects]="listRegisterLevel"
            [mbType]="isSubmitted && registerLevel.get('registerLevelId').errors ? 'error' : 'default'"
            [mbShowError]=" isSubmitted &&registerLevel.get('registerLevelId').errors != null"
            [mbErrors]="registerLevel.get('registerLevelId').errors" [mbErrorDefs]="[
                            { errorName: 'required',  errorDescription: 'staffAbs.validate.required' | translate: {'param': 'staffAbs.approvalFlow.registerLevel' | translate }},
                            { errorName: 'dublicate', errorDescription: 'staffAbs.validate.dublicate' | translate}]"
            mbPlaceholder="--{{'staffAbs.approvalFlow.registerLevel' | translate}}--"
            mbLabelText="{{'staffAbs.approvalFlow.registerLevel' | translate}} <span class='label__required'>*</span>">
          </mb-select>
        </div>

        <div nz-col nzXs="24" nzLg="6">
          <mb-select formControlName="hrLevelCode" [mbDataSelects]="listHRLevels"
            [mbType]="isSubmitted && registerLevel.get('hrLevelCode').errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && registerLevel.get('hrLevelCode').errors != null"
            [mbErrors]="registerLevel.get('hrLevelCode').errors"
            [mbErrorDefs]="[{ errorName: 'required',
                        errorDescription: 'staffAbs.validate.required' | translate: {'param': 'staffAbs.approvalFlow.hrLevel' | translate }}]"
            mbPlaceholder="--{{'staffAbs.approvalFlow.hrLevel' | translate}}--"
            mbLabelText="{{'staffAbs.approvalFlow.hrLevel' | translate}} <span class='label__required'>*</span>">
          </mb-select>
        </div>

        <div nz-col nzXs="24" nzLg="6">
          <mb-select formControlName="approvalLevelId" [mbDataSelects]="listRegisterLevel"
            [mbType]="isSubmitted && registerLevel.get('approvalLevelId').errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && registerLevel.get('approvalLevelId').errors != null"
            [mbErrors]="registerLevel.get('approvalLevelId').errors"
            [mbErrorDefs]="[{ errorName: 'required',
                        errorDescription: 'staffAbs.validate.required' | translate: {'param': 'staffAbs.approvalFlow.approvalLevel' | translate }}]"
            mbPlaceholder="--{{'staffAbs.approvalFlow.approvalLevel' | translate}}--"
            mbLabelText="{{'staffAbs.approvalFlow.approvalLevel' | translate}} <span class='label__required'>*</span>">
          </mb-select>
        </div>



        <div nz-col nzXs="24" nzLg="4" class="area-action">
          <mb-button mbButtonIconType="AWESOME" mbPrefixIcon="far fa-plus-circle" style="padding-top: 38px;"
            mbButtonSize="VERY_LARGE" mbButtonTextColor="#fff" mbButtonType="NO_BORDER" (click)="addRegisterLevel()"
            mbButtonBgColor="#141ED2"></mb-button>

          <mb-button mbButtonIconType="AWESOME" mbPrefixIcon="far fa-trash-alt" mbButtonSize="VERY_LARGE"
            [mbIsDisable]="first" mbButtonTextColor="#fff" mbButtonType="NO_BORDER" (click)="removeRegisterLevel(idx)"
            mbButtonBgColor="#FA0B0B">
          </mb-button>
        </div>

      </div>
    </div>
  </ng-container>
  <div *nzModalFooter>
    <button nz-button nzType="default" (click)="cancel()">{{'staffAbs.approvalFlow.cancel' |
      translate}}</button>
    <button nz-button nzType="primary" (click)="saveOrUpdate()">{{'staffAbs.approvalFlow.save' |
      translate}}</button>
  </div>
</form>
